<?
//<!-- $Id: _funkce.php,v 1.5 2002/04/17 11:49:38 vaclavik Exp $ -->
// pomocn funkce

function stred_odz ($stredisko)
{
  if ($stredisko % 1000 == 0) $vystup = "<b>";
  elseif ($stredisko % 100 == 0) $vystup = "&nbsp ";
  elseif ($stredisko % 10 == 0) $vystup = "&nbsp &nbsp ";
  else $vystup = "&nbsp &nbsp &nbsp ";
  return $vystup;
}

function stred_odk ($stredisko)
{
  if ($stredisko % 1000 == 0) $vystup = "</b>";
  else $vystup = "";
  return $vystup;
}

function addate ($datum, $dnu, $mesicu) //k danmu datu pipote poet dn
{
  $den = StrTok($datum, ".");
  $mesic = strtok(".");
  $rok = strtok(".");
  return Date("d.m.Y", mktime(0, 0, 0, $mesic+$mesicu, $den+$dnu, $rok+0));
}

function jm_prava ($i) //vrac jmno pstupovho prva
{
  if     ($i==0):  return "zkladn pstup";
  elseif ($i==1):  return "selnky";
  elseif ($i==2):  return "zamstnanci";
  elseif ($i==3):  return "etnictv";
  elseif ($i==4):  return "majetek";
  elseif ($i==5):  return "fakturace";
  elseif ($i==6):  return "sklady";
  elseif ($i==7):  return "mzdy";
  elseif ($i==8):  return "dokumenty";
  elseif ($i==9):  return "kalende";
  elseif ($i==10): return "pstupov prva";
  elseif ($i==11): return "kontrola a potvrzovn";
  elseif ($i==12): return "administrace systmu";
  endif;
}
function naz_prava ($i) //vrac jmno pstupovho prva
{
  if     ($i==0):  return "zak";
  elseif ($i==1):  return "cis";
  elseif ($i==2):  return "zam";
  elseif ($i==3):  return "uct";
  elseif ($i==4):  return "maj";
  elseif ($i==5):  return "fak";
  elseif ($i==6):  return "skl";
  elseif ($i==7):  return "mzd";
  elseif ($i==8):  return "dok";
  elseif ($i==9):  return "kal";
  elseif ($i==10): return "prv";
  elseif ($i==11): return "kon";
  elseif ($i==12): return "adm";
  endif;
}

function typdat ($data, $typ)   //kontrola ppustnosti dat ped provedenm sql dotazu
{
//kontroluje typy date, time, integer a double (float, real)
  $vystup = true;
  switch (strtolower(substr($typ,1,1))):
    case "t":
      $token = $strtok($data,":");
      if (!(gettype($token) == 'integer') or ($token<0) or ($token>23)) $vystup = false;
      $token = $strtok(":");
      if (!(gettype($token) == 'integer') or ($token<0) or ($token>59)) $vystup = false;
      $token = $strtok(":");
      if (!(gettype($token) == 'integer') or ($token<0) or ($token>59)) $vystup = false;
      break;
    case "d":
      $token = $strtok($data,".");
      if (!(gettype($token) == 'integer') or ($token<0) or ($token>31)) $vystup = false;
      $token = $strtok(".");
      if (!(gettype($token) == 'integer') or ($token<0) or ($token>12)) $vystup = false;
      $token = $strtok(".");
      if (!(gettype($token) == 'integer') or ($token<0) or ($token>2100)) $vystup = false;
      break;
    case "d":
    case "f":
    case "r":
      if(!(gettype($data) == 'integer') or !(gettype($data) == 'double')) $vystup = false;
      break;
    case "i":
      if(!(gettype($data) == 'integer')) $vystup = false;
      break;
  endswitch;
  return $vystup;
}

// funkce pro vytvoen formule - voln clovho skriptu, zkladn promnn - dle $nov
function otevri_detail ($vyber)
/* Podmnky pro pouit funkce:
   - Jmenn konvence skript:
     skript pro detailn pohled: $skript."-".$tabulka."-detail.php
     skript pro zpis:           $skript."-".$tabulka."-zapis.php
   - Argumenty skript:
     Pedv se parametr tvoc pln zadn klauzule WHERE v SQL dotazu.
     Takto je zapoteb zajistit voln vech veuvedench skript.
*/
{
  global $skript, $tabulka, $nov, $zamkni, $uz_znamka, $odemkni;
  if ($nov == 0): // zznam existuje - vyhledej zmek
    $vysledek = rdotaz ("SELECT zamek_uz FROM $tabulka WHERE $vyber");
    $zamek = Pg_result($vysledek, 0, zamek_uz);
  endif;
  if (isset($odemkni)): //odemkni zznam
    $vysledek = rdotaz ("UPDATE $tabulka SET zamek_uz=0, zamek_cas=0 WHERE $vyber");
    $zamkni = 1;
    echo"<form action=\"".$skript."-".$tabulka."-detail.php\" method=\"GET\"><input type=hidden name=\"ident\" value=\"$vyber\"><input type=hidden name=\"zamkni\" value=\"1\">";
  elseif ($nov == 1):  // nov zznam
    echo"<form action=\"".$skript."-".$tabulka."-zapis.php\" method=\"GET\"><input type=hidden name=\"nov\" value=\"$nov\">";
    $zamkni =  2; // zamknuto - lze zapsat
  elseif ($zamkni == "zamkni" or $uz_znamka == $zamek): // dost o uzamen existujcho zznamu nebo je uzameno aktulnm uivatelem
    if ($zamek == 0 or $uz_znamka == $zamek): // lze zamknout
      $vysledek = rdotaz ("UPDATE $tabulka SET zamek_uz=$uz_znamka, zamek_cas=0 WHERE $vyber"); //current_time
      echo"<form action=\"".$skript."-".$tabulka."-zapis.php\" method=\"GET\">
      <input type=hidden name=\"ident\" value=\"$vyber\">
      <input type=hidden name=\"zamkni\" value=\"1\">
      <input type=hidden name=\"nov\" value=\"$nov\">";
      $zamkni = 2; // zamknuto - lze zapsat
    else: //nelze zamknout
      echo"<form action=\"".$skript."-".$tabulka."-detail.php\" method=\"GET\"><input type=hidden name=\"ident\" value=\"$vyber\"><input type=hidden name=\"zamkni\" value=\"1\">";
    endif;
  else: //nezamykm, je mono zamknout
    echo"<form action=\"".$skript."-".$tabulka."-detail.php\" method=\"GET\"><input type=hidden name=\"ident\" value=\"$vyber\"><input type=hidden name=\"zamkni\" value=\"1\">";
  endif;
}

// funkce pro zpracovn poloky detailu - dle $nov zobraz poloku formule, nebo jen zobraz
function pol_detail ($promenna, &$hodnota, $delka, $zobrazit)
/* Zobraz celou buku poloky v zvislosti na nastaven promnnch
   (bu jen zobrazen, nebo poloka formule)
*/
{
  global $skript, $tabulka, $nov, $zamkni, $uz_znamka, $odemkni;
  echo "
  <td>&nbsp;";
  if (($nov == 1) OR ($zamkni == 2)): echo"<input type=\"text\" name=\"$promenna\" size=$zobrazit maxlength=$delka value=\"$hodnota\"\>";
  else: echo "$hodnota";
  endif;
  echo"
  </td>";
}

function polx_detail ($promenna, &$hodnota, $delka, $zobrazit)
/* Zobraz poloku v zvislosti na nastaven promnnch
   (bu jen zobrazen, nebo poloka formule)
*/
{
  global $skript, $tabulka, $nov, $zamkni, $uz_znamka, $odemkni;
  echo "&nbsp;";
  if (($nov == 1) OR ($zamkni == 2)): echo"<input type=\"text\" name=\"$promenna\" size=$zobrazit maxlength=$delka value=\"$hodnota\"\>";
  else: echo "$hodnota";
  endif;
}


// funkce pro vytvoen tlatek na dn strnky dle stavu zpracovn
function zavri_detail ($vyber)
/* Viz poznmky k veuveden funkci otevri_detail
*/
{
  global $skript, $tabulka, $nov, $zamkni;
  if ($zamkni==2): // zameno - zapi a (ma)
    echo"
      <td><center><input type=\"submit\" name=\"zapi\" value=\"zapi\"></center></form></td>
      <td>
        <center><form><input type=\"submit\" name=\"odemkni\" value=\"odemkni\">
        <input type=hidden name=\"ident\" value=\"$vyber\"></center></form>
      </td>";
    if ($nov==0): //star zznam me smazat
      echo"
      <td><center>
        <form action=\"".$skript."-".$tabulka."-smaz.php\" method=\"get\">
        <input type=hidden name=\"ident\" value=\"$vyber\">
        <input type=\"submit\" value=\"sma\"></form>
      </center></td>";
    endif;
  else: // nen zameno - zamkni
    echo"
      <td><center><input type=\"submit\" name=\"zamkni\" value=\"zamkni\"></center></form></td>";
  endif;
}

function ukaz_funkce ($retez) // vyhled a definuje funkce uivatele ze vstupnho etzce
/* formt vstupu: stedisko,kdy_funkce   kde:
     stedisko: vznamn slice pmo, voliteln znakem '?'
     kdy_funkce: etzec znak reprezentujcch funkce
   funkce vrt rkami oddlen seznam funkc (fce.ident)
   zatm nelze vcero skupin*/
{
  // rozloen etzce na stediska a funkce
  $strediska = strtok($retez,",");
  $fce = strtok (",");

  // stediska
  $odstred = "";
  $dostred = "";
  for ($i=0; $i<strlen($strediska); $i++):
    if ($strediska[$i] == '?'):  //tento znak k -vechny slice-
      $znakod = 0;
      $znakdo = 9;
    else: //znak je pevn definovn
      $znakod = $strediska[$i];
      $znakdo = $strediska[$i];
    endif;
    // vytvo clov etzce
    $odstred = $odstred.$znakod;
    $dostred = $dostred.$znakdo;
  endfor;

  // funkce
  $funkce = $fce[0];
  for ($i=1; $i<strlen($fce); $i++) $funkce = "$funkce','".$fce[$i];
  $vstup = "SELECT ident FROM fce WHERE stredisko >= $odstred AND stredisko <= $dostred AND funkce in ('$funkce')";
  $vysledek = rdotaz ($vstup);
  // vyhledn funkc a vytvoen seznamu
  $fci = Pg_NumRows($vysledek);
// echo "-$strediska-$odstred-$dostred---$fce-$funkce---$fci<br>";

  for ($i=0; $i < $fci; $i++):
    if ($i == 0) $vystup = Pg_result ($vysledek, 0, ident);
    else $vystup =  "$vystup,".Pg_result ($vysledek, $i, ident);
  endfor;

// echo "$vystup<br>";
  return $vystup;
}
?>